// Clase que usa un hilo para mostrar una animacin en las coordenadas indicadas:
// V 1.0 (C) Julio 2012 Salvador Pozo : Con Clase : http://conclase.net

#ifndef __HILOANIM_H__
#define __HILOANIM_H__

#include <cstring>
#include "hilopantalla.h"

class Animacion : public HiloPantalla {
    public:
        Animacion(int xi, int yi, int f, int c, int d, int ret, const char *a) :
            HiloPantalla(hiloAnimacion), cuadroactual(0), x(xi), y(yi), filas(f), cols(c), retardo(ret), cuadros(d)
        {
            int l = strlen(a)+1;
            anim = new char[l];
            std::strcpy(anim, a);
        }
        ~Animacion() {
            delete[] anim;
        }
    private:
        void Mostrar() const;
        void Esperar() { Sleep(retardo); }
        void SiguienteCuadro() {
            cuadroactual++;
            if(cuadroactual >= cuadros) cuadroactual = 0;
        }
        char *anim;
        int cuadroactual;
        int x;
        int y;
        int filas;
        int cols;
        int retardo;
        int cuadros;
        static DWORD WINAPI hiloAnimacion( void* );
};
#endif
