// Implementacin de la clase que usa un hilo para mostrar la hora en las coordenadas indicadas:
// V 1.0 (C) Julio 2012 Salvador Pozo : Con Clase : http://conclase.net

#include <cstdio>
#include "hilohora.h"

void Hora::Mostrar() const {
    COORD dwPos = {x, y};

    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
    std::printf("%02d:%02d:%02d", st.wHour, st.wMinute, st.wSecond);
}

void Hora::EsperarCambio() {
    while(seg == st.wSecond) {
        GetLocalTime(&st);
        Sleep(100);
    }
}

void Hora::ActualizarSeg() {
    seg = st.wSecond;
}

DWORD WINAPI Hora::hiloMostrarHora( void* par) {
    Hora *hora = (Hora*)par;  // Recuperar el parmetro, un puntero a Hora

    do {
        hora->EsperarCambio();
        if(hora->Reservar()) {
            hora->Mostrar();
            hora->Liberar();
        }
        hora->ActualizarSeg();
    } while(!hora->Salir()); // Repetir hasta que salir sea true

    return 0;
}

