// Clase virtual pura para crear hilos con acceso a pantalla:
// V 1.0 (C) Julio 2012 Salvador Pozo : Con Clase : http://conclase.net

#ifndef __HILOPANTALLA_H__
#define __HILOPANTALLA_H__

#include <windows.h>

class HiloPantalla {
    public:
        HiloPantalla( LPTHREAD_START_ROUTINE hilo ) {
            manipulador = CreateThread( 0, 0, hilo, (void*)this, 0, 0);
            hMutex = CreateMutex(NULL, FALSE, "MutexAccesoPantalla");
        }
        ~HiloPantalla() {
            CloseHandle(manipulador);
            CloseHandle(hMutex);
        }
        void Terminar() {
            salir = true;
            WaitForSingleObject(manipulador, INFINITE);
        }
    protected:
        virtual void Mostrar() const  = 0;
        bool Reservar() {
            if(WaitForSingleObject(HiloPantalla::hMutex, INFINITE) == WAIT_FAILED) return false;
            return true;
        }
        void Liberar() {
            ReleaseMutex(HiloPantalla::hMutex);
        }
        bool Salir() const { return salir; }
        static bool salir;
        HANDLE hMutex;
        HANDLE manipulador;
};
#endif
