// Implementacin de la clase que usa un hilo para mostrar un texto rotativo en las coordenadas indicadas,
// del ancho indicado, con un retardo y un texto:
// V 1.0 (C) Julio 2012 Salvador Pozo : Con Clase : http://conclase.net

#include <cstdio>
#include "hilorotativo.h"

void TextoRotativo::Rotar() {
    SMALL_RECT re1 = {x+1, y, x+ancho, y};
    COORD coor = {x, y};
    CHAR_INFO ci = { {(pos+ancho) >= longitud ? cadena[pos+ancho-longitud] : cadena[pos+ancho]},
        FOREGROUND_BLUE+FOREGROUND_GREEN+FOREGROUND_RED};

    ScrollConsoleScreenBuffer(GetStdHandle(STD_OUTPUT_HANDLE), &re1, 0, coor, &ci);
}

void TextoRotativo::Mostrar() const {
    COORD dwPos = {x, y};
    int n;

    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
    n = ancho < longitud-pos ? ancho : longitud-pos;
    WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), cadena+pos, n, 0, 0);
    if(ancho-n > 0)
       WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), cadena, ancho-n, 0, 0);
}

void TextoRotativo::IncrementaPos() {
    pos++;
    if(!cadena[pos]) pos = 0;
}

DWORD WINAPI TextoRotativo::hiloRotarTexto( void* par) {
    TextoRotativo *texto = (TextoRotativo*)par;

    // Texto inicial
    if(texto->Reservar()) {
        texto->Mostrar();
        texto->Liberar();
    }
    do {
        // Pintar 'ancho' caracteres a partir de (x,y), empezando en la
        // posicin 'pos' de la 'cadena':
        if(texto->Reservar()) {
            //texto->Rotar();
            texto->Mostrar();
            texto->Liberar();
            texto->IncrementaPos();
            texto->Esperar();
        }
    } while(!texto->Salir());
    return 0;
}

