// Clase que usa un hilo para mostrar un texto rotativo en las coordenadas indicadas,
// del ancho indicado, con un retardo y un texto:
// V 1.0 (C) Julio 2012 Salvador Pozo : Con Clase : http://conclase.net

#ifndef __HILOROTATIVO_H__
#define __HILOROTATIVO_H__

#include <cstring>
#include "hilopantalla.h"

class TextoRotativo : public HiloPantalla {
    public:
        TextoRotativo(int xc, int yc, int anchoc, int retc, const char *cad):
           HiloPantalla(hiloRotarTexto), pos(0), x(xc), y(yc), ancho(anchoc), retardo(retc) {
            longitud = std::strlen(cad);
            // Para que sea posible mostrar textos ms cortos que la anchura del mensaje rotativo
            // hay dos posibilidades:
            // 1) Aadir caracteres hasta que longitud==ancho
            // 2) Repetir el mensaje hasta que longitud>=ancho
            // Optamos por la 1 forma
            if(longitud < ancho) longitud = ancho;
            cadena = new char[longitud+1];
            std::strcpy(cadena, cad);
            while((int)std::strlen(cadena) < longitud) std::strcat(cadena, "-");
        }
        ~TextoRotativo() {
            delete[] cadena;
        }

    private:
        void Mostrar() const;
        void IncrementaPos();
        void Rotar();
        void Esperar() { Sleep(retardo); }
        char *cadena;
        int longitud;
        int pos;
        int x;
        int y;
        int ancho;
        int retardo;
        static DWORD WINAPI hiloRotarTexto( void* par );
};
#endif
